use arduino_hal::{
    hal::port::Dynamic,
    port::{
        mode::{Input, PullUp},
        Pin,
    },
};

// pub const DEBOUNCE_DELAY: u64 = 50;

pub struct Button {
    pub index: usize,
    pub pin: Pin<Input<PullUp>, Dynamic>,
    pub was_low: bool,
    // pub last_debounce_time: u64,
}

impl Button {
    pub fn new(index: usize, pin: Pin<Input<PullUp>, Dynamic>) -> Self {
        Button {
            index,
            was_low: pin.is_low(),
            pin,
            // last_debounce_time: 0,
        }
    }

    pub fn check_state<F>(&mut self, mut f: F)
    where
        F: FnMut(usize, bool),
    {
        // check if current state is different from previous one
        if self.pin.is_high() == self.was_low {
            // change state
            self.was_low = !self.was_low;

            //
            f(self.index, !self.was_low);
        }
    }
}
